package bstest

import (
	"time"

	. "gitlab.dms3.io/dms3/go-blockservice"

	bitswap "gitlab.dms3.io/dms3/go-bitswap"
	testinstance "gitlab.dms3.io/dms3/go-bitswap/testinstance"
	tn "gitlab.dms3.io/dms3/go-bitswap/testnet"
	delay "gitlab.dms3.io/dms3/go-dms3-delay"
	mockrouting "gitlab.dms3.io/dms3/go-dms3-routing/mock"
)

// Mocks returns |n| connected mock Blockservices
func Mocks(n int) []BlockService {
	net := tn.VirtualNetwork(mockrouting.NewServer(), delay.Fixed(0))
	bsOpts := []bitswap.Option{bitswap.ProvideEnabled(false), bitswap.ProviderSearchDelay(50 * time.Millisecond)}
	sg := testinstance.NewTestInstanceGenerator(net, nil, bsOpts)

	instances := sg.Instances(n)

	var servs []BlockService
	for _, i := range instances {
		servs = append(servs, New(i.Blockstore(), i.Exchange))
	}
	return servs
}
